// Program to demonstrate some nifty C++11 features
#include <iostream>
#include <list>
#include <vector>

using namespace std;

double squareIt(double x)
{
    return x*x;
}

//function names aligned
auto tripleIt(double x) -> double; //not implemented
auto quadrupleIt(double x) -> double
{
    return squareIt(x) * squareIt(x);
}

void setValue (int &x) {
    x = 4;
}

///////////////////
int main()
{
    //Using auto in declarations
    
    auto alpha = 5.7f;  //inferred type
    auto flag = true;   //inferred type
    
    cout<<flag<<endl;
    
    auto squared = squareIt(alpha); //inferred type from return type
    
    cout<<squared<<endl;
    
    cout<<quadrupleIt(alpha)<<endl; //inferred type from return type
    
    //for each loops
    
    //print the first 11 fibonacci numbers
    int fib[] = { 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89 };
    for (int number : fib) // iterate over array fib
        cout << number << ' '; // access the ith array element via number
    cout<<endl;
    
    //sum the first 11 fibonacci numbers, use auto and const &
    auto sum = 0;
    for (auto const &number : fib) // iterate over array fib
        sum += number; // access the ith array element via number
    
    cout<<sum<<endl;
    
    //change the array, use auto and &
    for (auto  &number : fib) // iterate over array fib
        number *= 2; // access the ith array element via number
    
    for (auto const &number : fib) // iterate over array fib
        cout << number << ' '; // access the ith array element via number
    
    cout<<endl;
    
    //using for each and for_each loops with lists
    list<int> l;
    l.push_back(3);
    l.push_back(5);
    l.push_back(7);
    
    for(auto const &number : l)
        cout << number << ' '; // access the ith list element via number
    
    cout<<endl;
    
    //using for_each
    
    for_each(l.begin(), l.end(), setValue);
    
    for(auto const &number : l)
        cout << number << ' '; // access the ith list element via number
    
    cout<<endl;

    return 0;
}