//Some advanced C++ features
#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

class Sum
{
  public:
    Sum() { sum = 0; }
    void operator()(int n) { sum += n; }
    int getSum() const { return sum; }
  private:
    int sum;
};

int main()
{
    vector<int> nums {3, 4, 2, 9, 15, 267};
    
    cout << "before: ";
    for (auto n : nums) {
        cout << n << " ";
    }
    cout << endl;
    
    //define the function to be applied via lambda notation
    //the function adds 1 to each vector element
    for_each(nums.begin(), nums.end(), [](int &n){ n++; });
    
    Sum s; //now s.sum is 0
    
    //apply Sum's operator() to each vector element and return the
    //function (class) object and assign it to s
    s = for_each(nums.begin(), nums.end(), Sum());
    
    cout << "after:  ";
    for (auto n : nums) {
        cout << n << " ";
    }
    cout << endl;
    cout << "sum: " << s.getSum() << endl;
    
    return 0;
}